#include <assert.h>
#include "scalar.h"
#include "vector.h"


/*
... explain what this does later! ...
*/
Vector bounce(Vector v, Vector n) {
    return v - (2 * dot(n, v)) * n;
}


void unitTestSum() {
    /* this test that vector-sum is indeed commutative (sanity check) */
    Vector a(5, -6, 9.5), b(2, 3, 5);
    assert(isEqual(a + b, b + a));
}

void unitTestCross() {
    Vector a(5, -6, 9.5), b(2, 3, 5);
    Vector c = cross(a, b);
    Vector d = cross(b, a);
    assert(isEqual(c, -d));
    assert(isZero(dot(a, c)));
    assert(isZero(dot(b, c)));
}

int main()
{
    // just some examples of usage of class Vectors
    Vector v, w(2, 3, 5);
    v.x = 2;
    v = v.sum(w);
    v = v.operator+(w);
    v = v + w;
    Scalar k = dot(v,v);

    //v = v + 2; ERROR

    unitTestSum();
    unitTestCross();
    return 0;
}